xine-lib: config_values_s Struct Reference

xine-lib 1.2.12

Data Fields
config_values_s Struct Reference

`#include <configfile.h>`

## Data Fields
char *(* | register_string )(config_values_t *self, const char *key, const char *def_value, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)
char *(* | register_filename )(config_values_t *self, const char *key, const char *def_value, int req_type, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)
int(* | register_range )(config_values_t *self, const char *key, int def_value, int min, int max, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)
int(* | register_enum )(config_values_t *self, const char *key, int def_value, char **values, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)
int(* | register_num )(config_values_t *self, const char *key, int def_value, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)
int(* | register_bool )(config_values_t *self, const char *key, int def_value, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)
void(* | register_entry )(config_values_t *self, cfg_entry_t *entry)
void(* | update_num )(config_values_t *self, const char *key, int value)
void(* | update_string )(config_values_t *self, const char *key, const char *value)
int(* | parse_enum )(const char *str, const char **values)
cfg_entry_t *(* | lookup_entry )(config_values_t *self, const char *key)
| lookup config entries More...
void(* | unregister_callback )(config_values_t *self, const char *key)
void(* | dispose )(config_values_t *self)
void(* | set_new_entry_callback )(config_values_t *self, xine_config_cb_t new_entry_cb, void *cb_data)
void(* | unset_new_entry_callback )(config_values_t *self)
char *(* | get_serialized_entry )(config_values_t *self, const char *key)
char *(* | register_serialized_entry )(config_values_t *self, const char *value)
cfg_entry_t * | first
cfg_entry_t * | last
cfg_entry_t * | cur
xine_config_cb_t | new_entry_cb
void * | new_entry_cbdata
pthread_mutex_t | config_lock
int | current_version
int(* | unregister_callbacks )(config_values_t *self, const char *key, xine_config_cb_t changed_cb, void *cb_data, size_t cb_data_size)
xine_t * | xine
char *(* | lookup_string )(config_values_t *, const char *key)
void(* | free_string )(config_values_t *, char **)
int(* | lookup_num )(config_values_t *, const char *key, int def_value)

## Field Documentation

## ◆ config_lock

pthread_mutex_t config_values_s::config_lock

mutex for modification to the config

Referenced by _x_config_change_opt(), xine_config_get_first_entry(), xine_config_get_next_entry(), xine_config_lookup_entry(), and xine_config_reset().

## ◆ cur

cfg_entry_t * config_values_s::cur

Referenced by _new_entry_cb(), config_get_current_entry(), xine_config_get_first_entry(), xine_config_get_next_entry(), xine_config_lookup_entry(), and xine_config_reset().

## ◆ current_version

int config_values_s::current_version

current config file's version number

## ◆ dispose

void(* config_values_s::dispose) (config_values_t *self)

dispose of all config entries in memory

## ◆ first

cfg_entry_t* config_values_s::first

config values are stored here:

Referenced by xine_config_get_first_entry(), and xine_config_reset().

## ◆ free_string

void(* config_values_s::free_string) (config_values_t *, char **)

Referenced by ao_alsa_mixer_init().

## ◆ get_serialized_entry

char *(* config_values_s::get_serialized_entry) (config_values_t *self, const char *key)

serialize a config entry. return a base64 null terminated string.

## ◆ last

cfg_entry_t * config_values_s::last

Referenced by xine_config_reset().

## ◆ lookup_entry

cfg_entry_t *(* config_values_s::lookup_entry) (config_values_t *self, const char *key)

lookup config entries

remember to call the changed_cb if it exists and you changed the value of this item

Referenced by _x_config_change_opt(), _x_input_get_default_server_mrls(), _x_input_get_show_hidden_files(), ao_pulse_open(), faad_init_plugin(), load_syms_linux(), open_plugin(), open_radio_capture_device(), open_video_capture_device(), search_by_channel(), sub_read_file(), tls_get_verify_tls_cert(), v4l_class_get_instance(), v4l_class_get_radio_instance(), v4l_class_get_video_instance(), vaapi_check_capability(), xine_config_lookup_entry(), xine_nbc_init(), and xv_prop_conf().

## ◆ lookup_num

int(* config_values_s::lookup_num) (config_values_t *, const char *key, int def_value)

convenience function to lookup numeric values

## ◆ lookup_string

char *(* config_values_s::lookup_string) (config_values_t *, const char *key)

MT-safe convenience function to lookup string values. Returns copy of current value or NULL. Returned string must be freed with config->free_string().

Referenced by ao_alsa_mixer_init().

## ◆ new_entry_cb

xine_config_cb_t config_values_s::new_entry_cb

new entry callback

## ◆ new_entry_cbdata

void* config_values_s::new_entry_cbdata

## ◆ parse_enum

int(* config_values_s::parse_enum) (const char *str, const char **values)

small utility function for enum handling

## ◆ register_bool

int(* config_values_s::register_bool) (config_values_t *self, const char *key, int def_value, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)

Referenced by _get_instance(), _register_config(), _x_alphablend_init(), _x_ao_new_port(), _x_input_register_show_hidden_files(), _x_vo_scale_init(), ao_alsa_mixer_init(), dvb_plugin_open(), init_class(), init_config(), init_plugin(), init_spu_decoder_plugin(), init_video_plugin(), lavc_on_update_format(), open_plugin(), opengl2_open_plugin(), pgx64_init_driver(), spucc_register_cfg_vars(), tls_register_config_keys(), vaapi_check_capability(), vaapi_open_plugin(), vcd_init(), vdpau_open_plugin(), xine_config_register_bool(), and xv_prop_conf().

## ◆ register_entry

void(* config_values_s::register_entry) (config_values_t *self, cfg_entry_t *entry)

not yet implemented

## ◆ register_enum

int(* config_values_s::register_enum) (config_values_t *self, const char *key, int def_value, char **values, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)

Referenced by _x_ao_new_port(), _x_osd_renderer_init(), bluray_init_plugin(), goom_init_plugin(), init_class(), init_config(), init_spu_decoder_plugin(), init_video_class(), init_video_plugin(), input_http_init_class(), multirate_pref_get(), open_plugin(), rtsp_session_start(), spucc_register_cfg_vars(), vaapi_open_plugin(), vcd_init(), vdpau_open_plugin(), xine_config_register_enum(), and xine_probe_fast_memcpy().

## ◆ register_filename

char *(* config_values_s::register_filename) (config_values_t *self, const char *key, const char *def_value, int req_type, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)

Referenced by _x_real_codecs_init(), bluray_init_plugin(), file_input_init_plugin(), get_win32_codecs_path(), init_class(), init_plugin(), init_radio_class(), init_spu_decoder_plugin(), init_video_class(), open_fb_device(), vcd_init(), and xine_config_register_filename().

## ◆ register_num

int(* config_values_s::register_num) (config_values_t *self, const char *key, int def_value, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)

Referenced by _get_instance(), _x_ao_new_port(), _x_audio_decoder_init(), _x_metronom_init(), _x_video_decoder_init(), _x_vo_new_port(), bluray_init_plugin(), dxr3_scr_init(), dxr3_spudec_open_plugin(), dxr3_vo_init_plugin(), faad_init_plugin(), goom_init_plugin(), init_audio_plugin(), init_class(), init_plugin(), init_spu_decoder_plugin(), init_sputext_demux_class(), init_video_plugin(), input_http_init_class(), multirate_pref_get(), open_plugin_fb(), pgx64_init_driver(), spucc_register_cfg_vars(), vaapi_open_plugin(), vcd_init(), vdpau_open_plugin(), and xine_config_register_num().

## ◆ register_range

int(* config_values_s::register_range) (config_values_t *self, const char *key, int def_value, int min, int max, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)

Referenced by _x_ao_new_port(), _x_vo_scale_init(), init_config(), init_plugin(), init_video_plugin(), lavc_on_update_format(), vaapi_check_capability(), vdpau_open_plugin(), xine_config_register_range(), and xv_prop_conf().

## ◆ register_serialized_entry

char *(* config_values_s::register_serialized_entry) (config_values_t *self, const char *value)

deserialize a config entry. value is a base 64 encoded string return the key of the serialized entry

## ◆ register_string

char *(* config_values_s::register_string) (config_values_t *self, const char *key, const char *def_value, const char *description, const char *help, int exp_level, xine_config_cb_t changed_cb, void *cb_data)

Referenced by _x_input_register_default_servers(), bluray_init_plugin(), init_class(), init_plugin(), init_spu_decoder_plugin(), input_http_init_class(), multirate_pref_get(), spucc_register_cfg_vars(), vcd_init(), and xine_config_register_string().

## ◆ set_new_entry_callback

void(* config_values_s::set_new_entry_callback) (config_values_t *self, xine_config_cb_t new_entry_cb, void *cb_data)

callback called when a new config entry is registered

Referenced by _load_plugin_class().

## ◆ unregister_callback

void(* config_values_s::unregister_callback) (config_values_t *self, const char *key)

unregister all entry callback functions for this key. if there may be multiple callbacks on different cb_data, consider using unregister_callbacks (self, NULL, NULL, my_data, sizeof (*my_data)) before freeing each instance instead. this also eliminates the need to unregister every key separately.

Referenced by _module_dispose(), faad_class_unref(), spudec_dispose(), and vcd_class_dispose().

## ◆ unregister_callbacks

int(* config_values_s::unregister_callbacks) (config_values_t *self, const char *key, xine_config_cb_t changed_cb, void *cb_data, size_t cb_data_size)

unregister multiple entry callback functions. all 3 values need to match unless they are NULL. if cb_data_size is not zero, data pointers within the range (cb_data <= ptr < cb_data + cb_data_size) will match. returns the count of unregistered functions.

Referenced by _x_vo_scale_cleanup(), bluray_class_dispose(), cdda_class_dispose(), dispose_audio_class(), dispose_class(), dispose_video_class(), dvd_class_dispose(), file_input_class_dispose(), hls_input_class_dispose(), http_class_dispose(), mms_class_dispose(), mpd_input_class_dispose(), osd_renderer_close(), xine_config_unregister_callbacks(), xine_dispose_internal(), and xine_side_dispose_internal().

## ◆ unset_new_entry_callback

void(* config_values_s::unset_new_entry_callback) (config_values_t *self)

unregister the callback

Referenced by _load_plugin_class().

## ◆ update_num

void(* config_values_s::update_num) (config_values_t *self, const char *key, int value)

convenience function to update range, enum, num and bool values

Referenced by dvb_plugin_open(), dvbspeed_init(), input_http_init_class(), tuner_set_channel(), update_fast_memcpy(), vaapi_check_capability(), vaapi_open_plugin(), vdpau_open_plugin(), and xine_probe_fast_memcpy().

## ◆ update_string

void(* config_values_s::update_string) (config_values_t *self, const char *key, const char *value)

convenience function to update string values

Referenced by ao_alsa_mixer_init(), input_http_init_class(), and open_fb_device().

## ◆ xine

xine_t* config_values_s::xine

Set this manually to enable logging.

Referenced by _x_config_change_opt(), ao_alsa_mixer_init(), ao_sun_open_plugin(), dvb_plugin_open(), dxr3_vo_open_plugin(), fb_open_plugin(), open_jack_plugin(), open_plugin(), open_plugin_2(), open_plugin_fb(), opengl2_open_plugin(), opengl_open_plugin(), pgx64_init_driver(), spudec_dispose(), tuner_set_channel(), vaapi_open_plugin(), vcd_class_dispose(), vdpau_open_plugin(), xshm_open_plugin(), and xshm_open_plugin_2().

The documentation for this struct was generated from the following file:

- xine-lib-1.2.12/include/xine/configfile.h